# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.accounting_code_category import AccountingCodeCategory
from zuora_sdk.models.accounting_code_status import AccountingCodeStatus
from zuora_sdk.models.accounting_code_type import AccountingCodeType
from typing import Optional, Set
from typing_extensions import Self

class AccountingCodeItemResponse(BaseModel):
    """
    AccountingCodeItemResponse
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    category: Optional[AccountingCodeCategory] = None
    created_by: Optional[StrictStr] = Field(default=None, description="The ID of the user who created the accounting code. ", alias="createdBy")
    created_on: Optional[StrictStr] = Field(default=None, description="Date and time when the accounting code was created. ", alias="createdOn")
    gl_account_name: Optional[StrictStr] = Field(default=None, description="Name of the account in your general ledger.  Field only available if you have Zuora Finance enabled. ", alias="glAccountName")
    gl_account_number: Optional[StrictStr] = Field(default=None, description="Account number in your general ledger.  Field only available if you have Zuora Finance enabled. ", alias="glAccountNumber")
    id: Optional[StrictStr] = Field(default=None, description="ID of the accounting code. ")
    name: Optional[StrictStr] = Field(default=None, description="Name of the accounting code. ")
    notes: Optional[StrictStr] = Field(default=None, description="Any optional notes for the accounting code. ")
    status: Optional[AccountingCodeStatus] = None
    type: Optional[AccountingCodeType] = None
    updated_by: Optional[StrictStr] = Field(default=None, description="The ID of the user who last updated the accounting code. ", alias="updatedBy")
    updated_on: Optional[StrictStr] = Field(default=None, description="Date and time when the accounting code was last updated. ", alias="updatedOn")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["category", "createdBy", "createdOn", "glAccountName", "glAccountNumber", "id", "name", "notes", "status", "type", "updatedBy", "updatedOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountingCodeItemResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountingCodeItemResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "category": obj.get("category"),
            "createdBy": obj.get("createdBy"),
            "createdOn": obj.get("createdOn"),
            "glAccountName": obj.get("glAccountName"),
            "glAccountNumber": obj.get("glAccountNumber"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "status": obj.get("status"),
            "type": obj.get("type"),
            "updatedBy": obj.get("updatedBy"),
            "updatedOn": obj.get("updatedOn")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
