# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class AccountingCodeType(str, Enum):
    """
    If you want to create multiple accounting codes of the type `AccountsReceivable`, you need to have [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) enabled and contact [Zuora Global Support](http://support.zuora.com) to access the Multiple AR Accounting Codes feature. Note that `On-Account Receivable` is only available if you enable the Invoice Settlement feature.
    """

    """
    allowed enum values
    """
    ACCOUNTSRECEIVABLE = 'AccountsReceivable'
    ONACCOUNTRECEIVABLE = 'OnAccountReceivable'
    CASH = 'Cash'
    OTHERASSETS = 'OtherAssets'
    CUSTOMERCASHONACCOUNT = 'CustomerCashOnAccount'
    DEFERREDREVENUE = 'DeferredRevenue'
    SALESTAXPAYABLE = 'SalesTaxPayable'
    OTHERLIABILITIES = 'OtherLiabilities'
    SALESREVENUE = 'SalesRevenue'
    SALESDISCOUNTS = 'SalesDiscounts'
    OTHERREVENUE = 'OtherRevenue'
    OTHEREQUITY = 'OtherEquity'
    BADDEBT = 'BadDebt'
    OTHEREXPENSES = 'OtherExpenses'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccountingCodeType from a JSON string"""
        return cls(json.loads(json_str))


