# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ApplyDiscountTo(str, Enum):
    """
    Specifies the type of charges a specific discount applies to.   This field is only used when applied to a discount charge model. If you are not using a discount charge model, the value is null.  Possible values:  * `RECURRING` * `USAGE` * `ONETIMERECURRING` * `ONETIMEUSAGE` * `RECURRINGUSAGE` * `ONETIMERECURRINGUSAGE` 
    """

    """
    allowed enum values
    """
    ONETIME = 'ONETIME'
    RECURRING = 'RECURRING'
    USAGE = 'USAGE'
    ONETIMERECURRING = 'ONETIMERECURRING'
    ONETIMEUSAGE = 'ONETIMEUSAGE'
    RECURRINGUSAGE = 'RECURRINGUSAGE'
    ONETIMERECURRINGUSAGE = 'ONETIMERECURRINGUSAGE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ApplyDiscountTo from a JSON string"""
        return cls(json.loads(json_str))


