# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ExpandedBillingRun(BaseModel):
    """
    ExpandedBillingRun
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = None
    created_by_id: Optional[StrictStr] = Field(default=None, alias="createdById")
    created_date: Optional[StrictStr] = Field(default=None, alias="createdDate")
    updated_by_id: Optional[StrictStr] = Field(default=None, alias="updatedById")
    updated_date: Optional[StrictStr] = Field(default=None, alias="updatedDate")
    billing_run_number: Optional[StrictStr] = Field(default=None, alias="billingRunNumber")
    billing_run_type: Optional[StrictStr] = Field(default=None, alias="billingRunType")
    end_date: Optional[StrictStr] = Field(default=None, alias="endDate")
    error_message: Optional[StrictStr] = Field(default=None, alias="errorMessage")
    executed_date: Optional[StrictStr] = Field(default=None, alias="executedDate")
    invoice_date: Optional[date] = Field(default=None, alias="invoiceDate")
    name: Optional[StrictStr] = None
    number_of_accounts: Optional[StrictInt] = Field(default=None, alias="numberOfAccounts")
    number_of_invoices: Optional[StrictInt] = Field(default=None, alias="numberOfInvoices")
    number_of_credit_memos: Optional[StrictInt] = Field(default=None, alias="numberOfCreditMemos")
    posted_date: Optional[StrictStr] = Field(default=None, alias="postedDate")
    start_date: Optional[StrictStr] = Field(default=None, alias="startDate")
    status: Optional[StrictStr] = None
    target_date: Optional[date] = Field(default=None, alias="targetDate")
    target_type: Optional[StrictStr] = Field(default=None, alias="targetType")
    total_time: Optional[StrictInt] = Field(default=None, alias="totalTime")
    account_id: Optional[StrictStr] = Field(default=None, alias="accountId")
    bill_cycle_day: Optional[StrictStr] = Field(default=None, alias="billCycleDay")
    batches: Optional[StrictStr] = None
    no_email_for_zero_amount_invoice: Optional[StrictBool] = Field(default=None, alias="noEmailForZeroAmountInvoice")
    auto_post: Optional[StrictBool] = Field(default=None, alias="autoPost")
    auto_email: Optional[StrictBool] = Field(default=None, alias="autoEmail")
    auto_renewal: Optional[StrictBool] = Field(default=None, alias="autoRenewal")
    invoices_emailed: Optional[StrictBool] = Field(default=None, alias="invoicesEmailed")
    last_email_sent_time: Optional[StrictStr] = Field(default=None, alias="lastEmailSentTime")
    target_date_off_set: Optional[StrictInt] = Field(default=None, alias="targetDateOffSet")
    invoice_date_off_set: Optional[StrictInt] = Field(default=None, alias="invoiceDateOffSet")
    charge_type_to_exclude: Optional[StrictStr] = Field(default=None, alias="chargeTypeToExclude")
    scheduled_execution_time: Optional[StrictStr] = Field(default=None, alias="scheduledExecutionTime")
    target_date_month_offset: Optional[StrictInt] = Field(default=None, alias="targetDateMonthOffset")
    target_date_day_of_month: Optional[StrictStr] = Field(default=None, alias="targetDateDayOfMonth")
    invoice_date_month_offset: Optional[StrictInt] = Field(default=None, alias="invoiceDateMonthOffset")
    invoice_date_day_of_month: Optional[StrictStr] = Field(default=None, alias="invoiceDateDayOfMonth")
    repeat_type: Optional[StrictStr] = Field(default=None, alias="repeatType")
    repeat_from: Optional[StrictStr] = Field(default=None, alias="repeatFrom")
    repeat_to: Optional[StrictStr] = Field(default=None, alias="repeatTo")
    run_time: Optional[StrictInt] = Field(default=None, alias="runTime")
    time_zone: Optional[StrictStr] = Field(default=None, alias="timeZone")
    monthly_on_day: Optional[StrictStr] = Field(default=None, alias="monthlyOnDay")
    weekly_on_day: Optional[StrictStr] = Field(default=None, alias="weeklyOnDay")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "createdById", "createdDate", "updatedById", "updatedDate", "billingRunNumber", "billingRunType", "endDate", "errorMessage", "executedDate", "invoiceDate", "name", "numberOfAccounts", "numberOfInvoices", "numberOfCreditMemos", "postedDate", "startDate", "status", "targetDate", "targetType", "totalTime", "accountId", "billCycleDay", "batches", "noEmailForZeroAmountInvoice", "autoPost", "autoEmail", "autoRenewal", "invoicesEmailed", "lastEmailSentTime", "targetDateOffSet", "invoiceDateOffSet", "chargeTypeToExclude", "scheduledExecutionTime", "targetDateMonthOffset", "targetDateDayOfMonth", "invoiceDateMonthOffset", "invoiceDateDayOfMonth", "repeatType", "repeatFrom", "repeatTo", "runTime", "timeZone", "monthlyOnDay", "weeklyOnDay"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpandedBillingRun from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpandedBillingRun from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "updatedById": obj.get("updatedById"),
            "updatedDate": obj.get("updatedDate"),
            "billingRunNumber": obj.get("billingRunNumber"),
            "billingRunType": obj.get("billingRunType"),
            "endDate": obj.get("endDate"),
            "errorMessage": obj.get("errorMessage"),
            "executedDate": obj.get("executedDate"),
            "invoiceDate": obj.get("invoiceDate"),
            "name": obj.get("name"),
            "numberOfAccounts": obj.get("numberOfAccounts"),
            "numberOfInvoices": obj.get("numberOfInvoices"),
            "numberOfCreditMemos": obj.get("numberOfCreditMemos"),
            "postedDate": obj.get("postedDate"),
            "startDate": obj.get("startDate"),
            "status": obj.get("status"),
            "targetDate": obj.get("targetDate"),
            "targetType": obj.get("targetType"),
            "totalTime": obj.get("totalTime"),
            "accountId": obj.get("accountId"),
            "billCycleDay": obj.get("billCycleDay"),
            "batches": obj.get("batches"),
            "noEmailForZeroAmountInvoice": obj.get("noEmailForZeroAmountInvoice"),
            "autoPost": obj.get("autoPost"),
            "autoEmail": obj.get("autoEmail"),
            "autoRenewal": obj.get("autoRenewal"),
            "invoicesEmailed": obj.get("invoicesEmailed"),
            "lastEmailSentTime": obj.get("lastEmailSentTime"),
            "targetDateOffSet": obj.get("targetDateOffSet"),
            "invoiceDateOffSet": obj.get("invoiceDateOffSet"),
            "chargeTypeToExclude": obj.get("chargeTypeToExclude"),
            "scheduledExecutionTime": obj.get("scheduledExecutionTime"),
            "targetDateMonthOffset": obj.get("targetDateMonthOffset"),
            "targetDateDayOfMonth": obj.get("targetDateDayOfMonth"),
            "invoiceDateMonthOffset": obj.get("invoiceDateMonthOffset"),
            "invoiceDateDayOfMonth": obj.get("invoiceDateDayOfMonth"),
            "repeatType": obj.get("repeatType"),
            "repeatFrom": obj.get("repeatFrom"),
            "repeatTo": obj.get("repeatTo"),
            "runTime": obj.get("runTime"),
            "timeZone": obj.get("timeZone"),
            "monthlyOnDay": obj.get("monthlyOnDay"),
            "weeklyOnDay": obj.get("weeklyOnDay")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
