# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from zuora_sdk.models.callout_auth import CalloutAuth
from typing import Optional, Set
from typing_extensions import Self

class GetPublicNotificationDefinitionResponseCallout(BaseModel):
    """
    GetPublicNotificationDefinitionResponseCallout
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    active: Optional[StrictBool] = Field(default=True, description="The status of the callout. The default value is `true`.")
    callout_auth: Optional[CalloutAuth] = Field(default=None, alias="calloutAuth")
    callout_baseurl: Optional[Annotated[str, Field(min_length=10, strict=True)]] = Field(default=None, description="The callout URL. It must start with 'https://'", alias="calloutBaseurl")
    callout_params: Optional[Dict[str, StrictStr]] = Field(default=None, description="A key-value map of merge fields of this callout. ", alias="calloutParams")
    callout_retry: Optional[StrictBool] = Field(default=True, description="Specified whether to retry the callout when the callout fails. The default value is `true`.", alias="calloutRetry")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Description for the callout.")
    event_type_name: Optional[Annotated[str, Field(min_length=1, strict=True)]] = Field(default=None, description="The name of the custom event type.", alias="eventTypeName")
    http_method: Optional[StrictStr] = Field(default=None, alias="httpMethod")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the callout. If `calloutActive` is `true`, a callout is required. The eventTypeName of the callout MUST be the same as the eventTypeName.")
    name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The name of the created callout.")
    required_auth: Optional[StrictBool] = Field(default=None, description="Specifies whether the callout requires auth.", alias="requiredAuth")
    created_by: Optional[StrictStr] = Field(default=None, description="The user who created the notification definition.", alias="createdBy")
    updated_on: Optional[StrictStr] = Field(default=None, description="The time when the notification was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00", alias="updatedOn")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["active", "calloutAuth", "calloutBaseurl", "calloutParams", "calloutRetry", "description", "eventTypeName", "httpMethod", "id", "name", "requiredAuth", "createdBy", "updatedOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPublicNotificationDefinitionResponseCallout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of callout_auth
        if self.callout_auth:
            _dict['calloutAuth'] = self.callout_auth.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPublicNotificationDefinitionResponseCallout from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "active": obj.get("active") if obj.get("active") is not None else True,
            "calloutAuth": CalloutAuth.from_dict(obj["calloutAuth"]) if obj.get("calloutAuth") is not None else None,
            "calloutBaseurl": obj.get("calloutBaseurl"),
            "calloutParams": obj.get("calloutParams"),
            "calloutRetry": obj.get("calloutRetry") if obj.get("calloutRetry") is not None else True,
            "description": obj.get("description"),
            "eventTypeName": obj.get("eventTypeName"),
            "httpMethod": obj.get("httpMethod"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "requiredAuth": obj.get("requiredAuth"),
            "createdBy": obj.get("createdBy"),
            "updatedOn": obj.get("updatedOn")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
