# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class MitTransactionSource(str, Enum):
    """
    Payment transaction source used to differentiate the transaction source in Stored Credential Transaction framework.   - `C_Unscheduled`: Cardholder-initiated transaction (CIT) that does not occur on scheduled or regularly occurring dates.   - `M_Recurring`: Merchant-initiated transaction (MIT) that occurs at regular intervals.   - `M_Unscheduled`: Merchant-initiated transaction (MIT) that does not occur on scheduled or regularly occurring dates.   - `M_MOTO`: Mail Order Telephone Order (MOTO) payment transaction. This option is only available for credit card payments on Stripe v2. See [Overview of Stripe payment gateway integration](https://knowledgecenter.zuora.com/Zuora_Collect/Payment_gateway_integrations/Supported_payment_gateways/Stripe_Payment_Gateway/A_Overview_of_Stripe_payment_gateway_integration) for more information. 
    """

    """
    allowed enum values
    """
    C_UNSCHEDULED = 'C_Unscheduled'
    M_RECURRING = 'M_Recurring'
    M_UNSCHEDULED = 'M_Unscheduled'
    M_MOTO = 'M_MOTO'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of MitTransactionSource from a JSON string"""
        return cls(json.loads(json_str))


