# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.ramp_interval_charge_delta_metrics_delta_mrr_inner import RampIntervalChargeDeltaMetricsDeltaMrrInner
from zuora_sdk.models.ramp_interval_charge_delta_metrics_delta_quantity_inner import RampIntervalChargeDeltaMetricsDeltaQuantityInner
from typing import Optional, Set
from typing_extensions import Self

class RampIntervalChargeDeltaMetrics(BaseModel):
    """
    RampIntervalChargeDeltaMetrics
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    charge_number: Optional[StrictStr] = Field(default=None, description="The number of the rate plan charge.", alias="chargeNumber")
    delta_discount_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The discount delta amount for the TCB.", alias="deltaDiscountTcb")
    delta_discount_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The discount delta amount for the TCV.", alias="deltaDiscountTcv")
    delta_gross_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCB delta value before discount charges are applied.", alias="deltaGrossTcb")
    delta_gross_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCV delta value before discount charges are applied.", alias="deltaGrossTcv")
    delta_mrr: Optional[List[RampIntervalChargeDeltaMetricsDeltaMrrInner]] = Field(default=None, description="The MRR changing history of the current rate plan charge in the current ramp interval.", alias="deltaMrr")
    delta_net_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCB delta value after discount charges are applied.", alias="deltaNetTcb")
    delta_net_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCV delta value after discount charges are applied.", alias="deltaNetTcv")
    delta_quantity: Optional[List[RampIntervalChargeDeltaMetricsDeltaQuantityInner]] = Field(default=None, description="The charge quantity changing history of the current rate plan charge in the current ramp interval.", alias="deltaQuantity")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The ID of the corresponding product rate plan charge.", alias="productRatePlanChargeId")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The number of the subscription that the current rate plan charge belongs to.", alias="subscriptionNumber")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["chargeNumber", "deltaDiscountTcb", "deltaDiscountTcv", "deltaGrossTcb", "deltaGrossTcv", "deltaMrr", "deltaNetTcb", "deltaNetTcv", "deltaQuantity", "productRatePlanChargeId", "subscriptionNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RampIntervalChargeDeltaMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in delta_mrr (list)
        _items = []
        if self.delta_mrr:
            for _item_delta_mrr in self.delta_mrr:
                if _item_delta_mrr:
                    _items.append(_item_delta_mrr.to_dict())
            _dict['deltaMrr'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in delta_quantity (list)
        _items = []
        if self.delta_quantity:
            for _item_delta_quantity in self.delta_quantity:
                if _item_delta_quantity:
                    _items.append(_item_delta_quantity.to_dict())
            _dict['deltaQuantity'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RampIntervalChargeDeltaMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "chargeNumber": obj.get("chargeNumber"),
            "deltaDiscountTcb": obj.get("deltaDiscountTcb"),
            "deltaDiscountTcv": obj.get("deltaDiscountTcv"),
            "deltaGrossTcb": obj.get("deltaGrossTcb"),
            "deltaGrossTcv": obj.get("deltaGrossTcv"),
            "deltaMrr": [RampIntervalChargeDeltaMetricsDeltaMrrInner.from_dict(_item) for _item in obj["deltaMrr"]] if obj.get("deltaMrr") is not None else None,
            "deltaNetTcb": obj.get("deltaNetTcb"),
            "deltaNetTcv": obj.get("deltaNetTcv"),
            "deltaQuantity": [RampIntervalChargeDeltaMetricsDeltaQuantityInner.from_dict(_item) for _item in obj["deltaQuantity"]] if obj.get("deltaQuantity") is not None else None,
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "subscriptionNumber": obj.get("subscriptionNumber")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
