# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class RenewalSetting(str, Enum):
    """
    Specifies the type of the terms that follow the first term if the subscription is renewed. Only applicable if the type of the first term is `TERMED`.  * `RENEW_WITH_SPECIFIC_TERM` - Each renewal term has a predefined duration. The first entry in `renewalTerms` specifies the duration of the second term of the subscription, the second entry in `renewalTerms` specifies the duration of the third term of the subscription, and so on. The last entry in `renewalTerms` specifies the ultimate duration of each renewal term. * `RENEW_TO_EVERGREEN` - The second term of the subscription does not have a predefined duration. 
    """

    """
    allowed enum values
    """
    RENEW_WITH_SPECIFIC_TERM = 'RENEW_WITH_SPECIFIC_TERM'
    RENEW_TO_EVERGREEN = 'RENEW_TO_EVERGREEN'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RenewalSetting from a JSON string"""
        return cls(json.loads(json_str))


