# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ResumePolicy(str, Enum):
    """
    Resume methods. Specify a way to resume a subscription. See [Resume Date](https://knowledgecenter.zuora.com/BC_Subscription_Management/Subscriptions/Resume_a_Subscription#Resume_Date) for more information.  If `SuspendDate` is specfied, the resumption will take place on the same day as the suspension.  
    """

    """
    allowed enum values
    """
    TODAY = 'Today'
    FIXEDPERIODSFROMSUSPENDDATE = 'FixedPeriodsFromSuspendDate'
    FIXEDPERIODSFROMTODAY = 'FixedPeriodsFromToday'
    SPECIFICDATE = 'SpecificDate'
    SUSPENDDATE = 'SuspendDate'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ResumePolicy from a JSON string"""
        return cls(json.loads(json_str))


