# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class StartDatePolicy(str, Enum):
    """
    Start date policy of the discount charge to become active when the **Apply to billing period partially** checkbox is selected from the product catalog UI or the `applyToBillingPeriodPartially` field is set as true from the \"CRUD: Create a product rate plan charge\" operation.  If the value of this field is `SpecificDate`, use the `specificTriggerDate` field to specify the date when the charge becomes active. If the value of this field is `FixedPeriodAfterApplyToChargeStartDate`, the charge is active for a predefined duration based on the value of the `upToPeriodsType` and `upToPeriods` fields. 
    """

    """
    allowed enum values
    """
    ALIGNTOAPPLYTOCHARGE = 'AlignToApplyToCharge'
    SPECIFICDATE = 'SpecificDate'
    ENDOFLASTINVOICEPERIODOFAPPLYTOCHARGE = 'EndOfLastInvoicePeriodOfApplyToCharge'
    FIXEDPERIODAFTERAPPLYTOCHARGESTARTDATE = 'FixedPeriodAfterApplyToChargeStartDate'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of StartDatePolicy from a JSON string"""
        return cls(json.loads(json_str))


