# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class StoredCredentialProfileStatus(str, Enum):
    """
    The status of the stored credential profile.  * `Agreed` - The stored credential profile has not been validated via an authorization transaction with the payment gateway. * `Active` - The stored credential profile has been validated via an authorization transaction with the payment gateway. * `Cancelled` - The stored credentials are no longer valid, per a customer request. Zuora cannot use the stored credentials in transactions. * `Expired` - The stored credentials are no longer valid, per an expiration policy in the stored credential transaction framework. Zuora cannot use the stored credentials in transactions. 
    """

    """
    allowed enum values
    """
    AGREED = 'Agreed'
    ACTIVE = 'Active'
    CANCELLED = 'Cancelled'
    EXPIRED = 'Expired'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of StoredCredentialProfileStatus from a JSON string"""
        return cls(json.loads(json_str))


