# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class SuspendPolicy(str, Enum):
    """
    Suspend methods. Specify a way to suspend a subscription. See [Suspend Date](https://knowledgecenter.zuora.com/BC_Subscription_Management/Subscriptions/Suspend_a_Subscription#Suspend_Date) for more information. 
    """

    """
    allowed enum values
    """
    TODAY = 'Today'
    ENDOFLASTINVOICEPERIOD = 'EndOfLastInvoicePeriod'
    FIXEDPERIODSFROMTODAY = 'FixedPeriodsFromToday'
    SPECIFICDATE = 'SpecificDate'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SuspendPolicy from a JSON string"""
        return cls(json.loads(json_str))


